# Be sure to restart your server when you modify this file

# Specifies gem version of Rails to use when vendor/rails is not present
RAILS_GEM_VERSION = '2.3.14' unless defined? RAILS_GEM_VERSION

# Bootstrap the Rails environment, frameworks, and default configuration
require File.join(File.dirname(__FILE__), 'boot')

KIDNEY_APP_CONFIG = File.expand_path("#{RAILS_ROOT}/config/app_config.json")
KIDNEY_WEIGHT_CONFIG = File.expand_path("#{RAILS_ROOT}/config/weight.json")
KIDNEY_TEMPLATES_DIR = File.expand_path("#{RAILS_ROOT}/templates")
KIDNEY_CONSTRAINTS_DIR = File.expand_path("#{RAILS_ROOT}/constraints")

Rails::Initializer.run do |config|
  # Settings in config/environments/* take precedence over those specified here.
  # Application configuration should go into files in config/initializers
  # -- all .rb files in that directory are automatically loaded.

  # Add additional load paths for your own custom dirs
   config.autoload_paths += %W( #{RAILS_ROOT}/app/apis )

  # Specify gems that this application depends on and have them installed with rake gems:install
  config.gem "rubyjedi-actionwebservice", :lib => "action_web_service", :source => 'http://gems.github.com'
  config.gem "kidney_exchange", :lib => "kidney_exchange", :version => ">= 1.0.0"
  config.gem "kidney_models", :lib => "kidney_models", :version => ">= 0.0.1"
  config.gem "rack", :lib => "rack", :version => "1.1.0"
  config.gem "json_pure", :lib =>"json"
   
  # Only load the plugins named here, in the order given (default is alphabetical).
  # :all can be used as a placeholder for all plugins not explicitly named
  # config.plugins = [ :exception_notification, :ssl_requirement, :all ]

  # Skip frameworks you're not going to use. To use Rails without a database,
  # you must remove the Active Record framework.
  config.frameworks -= [ :active_record, :active_resource, :action_mailer ]

  # Activate observers that should always be running
  # config.active_record.observers = :cacher, :garbage_collector, :forum_observer

  # Set Time.zone default to the specified zone and make Active Record auto-convert to this zone.
  # Run "rake -D time" for a list of tasks for finding time zone names.
  config.time_zone = 'UTC'

  # The default locale is :en and all translations from config/locales/*.rb,yml are auto loaded.
  # config.i18n.load_path += Dir[Rails.root.join('my', 'locales', '*.{rb,yml}')]
  # config.i18n.default_locale = :de
end
