function description()
	return "iteration to minimise the number of 3-way exchanges"
end

function objective(all_cycles, num_altruistics)
	local objective = {}
	local total_cycles = all_cycles:TotalNumberOfCycles()

	for i=0,total_cycles-1 do
		local c = all_cycles:GetCycle(i)
        table.insert(objective, cycle_coeff(c))
	end
	
	for i = total_cycles, total_cycles + num_altruistics - 1 do
		table.insert(objective, 0)
	end
	
	return objective
end

function cycle_coeff(entry)
    if entry:Size() == 3 then
       return 1
    end
    return 0
end

function alt_coeff(altruisticId)
    return 0
end

function op()
	return KidneyConstraint.LEQ
end

function sense()
	return IPObjective.MIN
end

function bound(holder)
	return CycleListUtils.GetNumberOfNCycles(3, holder:Result())
end

function limit(problem_info)
    return 1
end

function dual(data_store)
    return math.ceil(data_store:UnboundedSize() / 3)
end

function all_integers()
    return true
end