function description()
	return "iteration to maximise the total number of backarcs"
end

function objective(all_cycles, num_altruistics)
	local objective = {}
	local total_cycles = all_cycles:TotalNumberOfCycles()

	for i=0,total_cycles-1 do
		table.insert(objective, all_cycles:GetCycle(i):BackArcCount())
	end
	
	for i = total_cycles, total_cycles + num_altruistics - 1 do
		table.insert(objective, 0)
	end
	
	return objective
end

function cycle_coeff(entry)
    return entry:BackArcCount()
end

function alt_coeff(altruisticId)
    return 0
end

function op()
	return KidneyConstraint.GEQ
end

function sense()
	return IPObjective.MAX
end

function bound(holder)
	return CycleListUtils.CountTotalBackarcs(holder:Result())
end

function limit(problem_info)
    return problem_info:MaxCycleSize()
end

function dual(data_store)
	return data_store:UnboundedSize()
end

function all_integers()
    return true
end