function description()
	return "iteration to maximise the number of effective 3-way exchanges"
end

function objective(all_cycles, num_altruistics)
	local objective = {}
	local total_cycles = all_cycles:TotalNumberOfCycles()

	for i=0,total_cycles-1 do
		local c = all_cycles:GetCycle(i);
        table.insert(objective, cycle_coeff(c))
	end
	
	for i = total_cycles, total_cycles + num_altruistics - 1 do
		table.insert(objective, 0)
	end
	
	return objective
end

function cycle_coeff(entry)
    if entry:Size() == 3 or  (entry:Size() == 4 and entry:ContainsEmbeddedNWays(3)) then
        return 1
	end
    return 0
end

function alt_coeff(altruisticId)
    return 0
end

function op()
	return KidneyConstraint.GEQ
end

function sense()
	return IPObjective.MAX
end

function bound(holder)
	total = 0;
	for entry in holder:ResultItor() do
		if entry:Size() == 3 or (entry:Size() == 4 and entry:ContainsEmbeddedNWays(3)) then
			total = total + 1
		end
	end
	return total
end

function limit(problem_info)
    return 1
end

function all_integers()
    return true
end