function description()
	return "iteration to minimise the number of 3-way exchanges"
end

function objective(all_cycles, num_altruistics)
	local objective = {}
	local total_cycles = all_cycles:TotalNumberOfCycles()

	for i=0,total_cycles-1 do
		local c = all_cycles:GetCycle(i);
		if c:Size() == 3 then
			table.insert(objective, 1)
		else
			table.insert(objective, 0)
		end
	end
	
	for i = total_cycles, total_cycles + num_altruistics - 1 do
		table.insert(objective, 0)
	end
	
	return objective
end

function op()
	return KidneyConstraint.LEQ
end

function sense()
	return IPObjective.MIN
end

function bound(holder)
	return CycleListUtils.GetNumberOfNCycles(3, holder:Result())
end