function description()
	return "iteration to maximise the number of effective pairwise exchanges"
end

function objective(all_cycles, num_altruistics)
	local objective = {}
	local total_cycles = all_cycles:TotalNumberOfCycles()

	for i=0,total_cycles-1 do
		local c = all_cycles:GetCycle(i);
		if c:Size() == 2 or c:BackArcCount() > 0 then
			table.insert(objective, 1)
		else
			table.insert(objective, 0)
		end
	end
	
	for i = total_cycles, total_cycles + num_altruistics - 1 do
		table.insert(objective, 0)
	end
	
	return objective
end

function op()
	return KidneyConstraint.GEQ
end

function sense()
	return IPObjective.MAX
end

function bound(holder)
	return CycleListUtils.GetNumberOfPotentialTwoCycles(holder:Result())
end