function description()
	return "iteration to maximise the total number of transplants"
end

function objective(all_cycles, num_altruistics)
	local objective = {}
	local total_cycles = all_cycles:TotalNumberOfCycles()
	
	for i=0,total_cycles-1 do
		table.insert(objective, all_cycles:GetCycle(i):Size())
	end
	
	for i = total_cycles, total_cycles + num_altruistics - 1 do
		table.insert(objective, 1)
	end
	
	return objective
end

function op()
	return KidneyConstraint.GEQ
end

function sense()
	return IPObjective.MAX
end

function bound(holder)
	return CycleListUtils.CountTotalTransplants(holder:Result()) + holder:NumUnusedAltruistics()
end