require 'kidney.so'

module KidneyExchange
  class KidneyAllocator
	def initialize(appConfigFile, weightConfigFile, templatesDir, constraintsDir)
		@appConfigFile = appConfigFile
		@weightConfigFile = weightConfigFile
		@templatesDir = templatesDir
		@constraintsDir = constraintsDir
	end
	
  	def find_json(data, operation, altruisticChainLength)
  		Kidney::Kidney.new(@appConfigFile, @weightConfigFile, @templatesDir, @constraintsDir).find(data, operation, "json", altruisticChainLength)
  	end
  	
  	def find_xml(data, operation, altruisticChainLength)
  		Kidney::Kidney.new(@appConfigFile, @weightConfigFile, @templatesDir, @constraintsDir).find(data, operation, "xml", altruisticChainLength)
  	end

  	def find_json_custom(data, operation, altruisticChainLength, maxCycleSize, constraintsString, outputFormat)
  		Kidney::Kidney.new(@appConfigFile, @weightConfigFile, @templatesDir, @constraintsDir).find_ex(data, operation, "json", altruisticChainLength,
																	  maxCycleSize, constraintsString, outputFormat)
  	end
  	
  	def find_xml_custom(data, operation, altruisticChainLength, maxCycleSize, constraintsString, outputFormat)
  		Kidney::Kidney.new(@appConfigFile, @weightConfigFile, @templatesDir, @constraintsDir).find_ex(data, operation, "xml", altruisticChainLength,
																      maxCycleSize, constraintsString, outputFormat)
  	end

	def get_available_constraints()
		return Kidney::Kidney.new(@appConfigFile, @weightConfigFile, @templatesDir, @constraintsDir).get_available_constraints();
	end
  end
end