require File.dirname(__FILE__) + '/spec_helper.rb'

describe "encapsulation of exchange data" do

  before(:each) do
	@attributes_v2 = {"algorithm"=>"Optimal set of exchanges with respect to the optimality criteria",
					  "output"=>{"all_cycles"=>{
						"0"=>{"cycle"=>[{"p"=>1,"d"=>1,"tb"=>0.049,"dif"=>3,"s"=>0},
										{"p"=>2,"d"=>2,"tb"=>0.049,"dif"=>3,"s"=>0}],
							  "backarcs"=>0,
							  "weight"=>6.098,
							  "alt"=>[],
							  "embedded"=>{}},
						"1"=>{"cycle"=>[{"d"=>16,"a"=>true,"tb"=>0.049,"dif"=>3,"s"=>100},
										{"p"=>19,"d"=>20,"tb"=>0.049,"dif"=>3,"s"=>0}],
							  "backarcs"=>0,
							  "weight"=>106.098,
							  "alt"=>[],
							  "embedded"=>{},
							  "altruistic"=>true},
						"2"=>{"cycle"=>[{"p"=>2,"d"=>2,"tb"=>0.049,"dif"=>3,"s"=>0},
									    {"p"=>3,"d"=>3,"tb"=>0.049,"dif"=>3,"s"=>0}],
							  "backarcs"=>0,
							  "weight"=>6.098,
							  "alt"=>[],
							  "embedded"=>{}},
						"3"=>{"cycle"=>[{"p"=>2,"d"=>2,"tb"=>0.049,"dif"=>3,"s"=>80},
										{"p"=>4,"d"=>4,"tb"=>0.049,"dif"=>3,"s"=>80}],
							  "backarcs"=>0,
							  "weight"=>166.098,
							  "alt"=>[],
							  "embedded"=>{}},
						"4"=>{"cycle"=>[{"d"=>15,"a"=>true,"tb"=>0.049,"dif"=>3,"s"=>20},
										{"p"=>19,"d"=>20,"tb"=>0.049,"dif"=>3,"s"=>0}],
							  "backarcs"=>0,
							  "weight"=>26.098,
							  "alt"=>[],
							  "embedded"=>{},
							  "altruistic"=>true},
						"5"=>{"cycle"=>[{"p"=>10,"d"=>10,"tb"=>0.049,"dif"=>3,"s"=>0},
										{"p"=>11,"d"=>11,"tb"=>0.049,"dif"=>3,"s"=>0}],
							  "backarcs"=>0,
							  "weight"=>6.098,
							  "alt"=>[],
							  "embedded"=>{},
							  "altruistic"=>true},
						"6"=>{"cycle"=>[{"p"=>6,"d"=>6,"tb"=>0.049,"dif"=>3,"s"=>0},
										{"p"=>7,"d"=>7,"tb"=>0.049,"dif"=>3,"s"=>0}],
							  "backarcs"=>0,
							  "weight"=>6.098,
							  "alt"=>[],
							  "embedded"=>{}},
						"7"=>{"cycle"=>[{"p"=>8,"d"=>8,"tb"=>0.049,"dif"=>3,"s"=>0},
										{"p"=>9,"d"=>9,"tb"=>0.049,"dif"=>3,"s"=>0}],
							  "backarcs"=>0,
							  "weight"=>6.098,
							  "alt"=>[],
							  "embedded"=>{}},
						"8"=>{"cycle"=>[{"p"=>17,"d"=>17,"tb"=>0.049,"dif"=>3,"s"=>0},
										{"p"=>18,"d"=>18,"tb"=>0.049,"dif"=>3,"s"=>40}],
							  "backarcs"=>0,
							  "weight"=>46.098,
							  "alt"=>[9],
							  "embedded"=>{}},
						"9"=>{"cycle"=>[{"p"=>17,"d"=>17,"tb"=>0.049,"dif"=>3,"s"=>0},
										{"p"=>18,"d"=>19,"tb"=>0.049,"dif"=>3,"s"=>50}],
							  "backarcs"=>0,
							  "weight"=>56.098,
							  "alt"=>[8],
							  "embedded"=>{}},
						"10"=>{"cycle"=>[{"p"=>1,"d"=>1,"b"=>0,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>2,"d"=>2,"b"=>2,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>3,"d"=>3,"tb"=>0.049,"dif"=>3,"s"=>0}],
							   "backarcs"=>2,
							   "weight"=>9.147,
							   "alt"=>[],
							   "embedded"=>{"2"=>[0,2]}},
						"11"=>{"cycle"=>[{"p"=>2,"d"=>2,"b"=>3,"tb"=>0.049,"dif"=>3,"s"=>80},
										 {"p"=>4,"d"=>4,"tb"=>0.049,"dif"=>3,"s"=>80},
										 {"p"=>5,"d"=>5,"tb"=>0.049,"dif"=>3,"s"=>80}],
							   "backarcs"=>1,
							   "weight"=>249.147,
							   "alt"=>[],
							   "embedded"=>{"2"=>[3]}},
						"12"=>{"cycle"=>[{"p"=>10,"d"=>10,"b"=>5,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>11,"d"=>11,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>14,"d"=>14,"tb"=>0.049,"dif"=>3,"s"=>0}],
							   "backarcs"=>1,
							   "weight"=>9.147,
							   "alt"=>[],
							   "embedded"=>{"2"=>[5]}},
						"13"=>{"cycle"=>[{"p"=>14,"d"=>14,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>12,"d"=>12,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>13,"d"=>13,"tb"=>0.049,"dif"=>3,"s"=>0}],
							   "backarcs"=>0,
							   "weight"=>9.147,
							   "alt"=>[],
							   "embedded"=>{}},
						"14"=>{"cycle"=>[{"p"=>12,"d"=>12,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>6,"d"=>6,"b"=>6,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>7,"d"=>7,"tb"=>0.049,"dif"=>3,"s"=>0}],
							   "backarcs"=>1,
							   "weight"=>9.147,
							   "alt"=>[],
							   "embedded"=>{"2"=>[6]}},
						"15"=>{"cycle"=>[{"p"=>13,"d"=>13,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>8,"d"=>8,"b"=>7,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>9,"d"=>9,"tb"=>0.049,"dif"=>3,"s"=>0}],
							   "backarcs"=>1,
							   "weight"=>9.147,
							   "alt"=>[2,3],
							   "embedded"=>{"2"=>[7]}},
 						"16"=>{"cycle"=>[{"p"=>13,"d"=>13,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>8,"d"=>8,"b"=>7,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>9,"d"=>9,"tb"=>0.049,"dif"=>3,"s"=>0},
										 {"p"=>10,"d"=>10,"tb"=>0.049,"dif"=>3,"s"=>0}],
							   "backarcs"=>1,
							   "weight"=>100,
							   "alt"=>[],
							   "embedded"=>{"2"=>[7],"3" =>[12,15]},
							   "altruistic"=>true}},
						"exchange_data"=>[{"description"=>"(COIN) iteration to maximise the number of effective pairwise exchanges, iteration to maximise the total number of transplants, iteration to maximise the number of altruistic donors, iteration to minimise the number of 3-way exchanges, iteration to maximise the total number of backarcs, iteration to maximise the total weight","exchanges"=>[1,5,6,7,9,10,13,14,16],"weight"=>298.784,"two_way_exchanges"=>5,"three_way_exchanges"=>2,"four_way_exchanges"=>1,"total_transplants"=>20,"unused_altruistics"=>[20,21]}]}}

    @exchange_data_v2 = KidneyModels::ExchangeData.new(@attributes_v2, 'optimal', 4)
  end
  
  it "should return 16 cycles in v2" do
    @exchange_data_v2.all_cycles.length.should == 17
  end

  it "should contain cycle with id 4 in v2" do
    @exchange_data_v2.all_cycles[4].nil? == false
  end
  
  it "should contain a cycle with id 4 with weight 26.098 in v2" do
    @exchange_data_v2.all_cycles[4].weight.should == 26.098
  end
  
  it "should contain a cycle with id 4 that contains an altruistic donor in v2" do
    @exchange_data_v2.all_cycles[4].altruistic.should == true
  end

  it "should contain a cycle with id 4 that is a two cycle in v2" do
    @exchange_data_v2.all_cycles[4].patients.length.should == 2
  end

  it "should contain a cycle with id 4 that has no embedded in v2" do
    @exchange_data_v2.all_cycles[4].embedded.length.should == 0
  end

  it "should contain cycle with id 15 in v2" do
    @exchange_data_v2.all_cycles[15].nil? == false
  end
  
  it "should contain a cycle with id 15 with weight 9.147 in v2" do
    @exchange_data_v2.all_cycles[15].weight.should == 9.147
  end
  
  it "should contain a cycle with id 15 does not contains an altruistic donor in v2" do
    @exchange_data_v2.all_cycles[15].altruistic.should == false
  end

  it "should contain a cycle with id 15 that is a three cycle in v2" do
    @exchange_data_v2.all_cycles[15].patients.length.should == 3
  end

  it "should contain a cycle with id 15 contains one embedded 2 way" do
    @exchange_data_v2.all_cycles[15].embedded.length.should == 1
    @exchange_data_v2.all_cycles[15].embedded[2].length.should == 1
  end

  it "should contain cycle with id 16 in v2" do
    @exchange_data_v2.all_cycles[16].nil? == false
  end
  
  it "should contain a cycle with id 16 with weight 100 in v2" do
    @exchange_data_v2.all_cycles[16].weight.should == 100
  end
  
  it "should contain a cycle with id 16 contains an altruistic donor in v2" do
    @exchange_data_v2.all_cycles[16].altruistic.should == true
  end

  it "should contain a cycle with id 16 that is a four cycle in v2" do
    @exchange_data_v2.all_cycles[16].patients.length.should == 4
  end

  it "should contain a cycle with id 16 contains one embedded 2 way and 2 embedded 3-ways" do
    @exchange_data_v2.all_cycles[16].embedded.length.should == 2
    @exchange_data_v2.all_cycles[16].embedded[2].length.should == 1
    @exchange_data_v2.all_cycles[16].embedded[3].length.should == 2
    
    @exchange_data_v2.all_cycles[16].embedded[2][0].should == 7
    @exchange_data_v2.all_cycles[16].embedded[3][0].should == 12
    @exchange_data_v2.all_cycles[16].embedded[3][1].should == 15
  end

  it "should contain a total of 10 2-ways in all cycles" do
    @exchange_data_v2.get_total_n_cycles_in_all_cycles(2) == 10
  end

  it "should contain a total of 6 3-ways in all cycles" do
    @exchange_data_v2.get_total_n_cycles_in_all_cycles(3) == 6
  end

  it "should contain a total of 1 4-way in all cycles" do
    @exchange_data_v2.get_total_n_cycles_in_all_cycles(4) == 1
  end

  it "should have one set of exchange data in v2" do
    @exchange_data_v2.exchanges.length.should == 1
  end

  it "should have weight 198.784 in v2" do
    @exchange_data_v2.exchanges[0].weight.should == 298.784
  end

  it "should have 5 2-ways in v2" do
    @exchange_data_v2.exchanges[0].get_num_n_ways(2).should == 5
  end

  it "should have 5 3-ways in v2" do
    @exchange_data_v2.exchanges[0].get_num_n_ways(3).should == 2
  end

  it "should have 1 4-way in v2" do
    @exchange_data_v2.exchanges[0].get_num_n_ways(4).should == 1
  end

  it "should have 0 5-ways in v2" do
    @exchange_data_v2.exchanges[0].get_num_n_ways(5).should == 0
  end

  it "should have 2 short-chains in v2" do
    @exchange_data_v2.exchanges[0].get_num_alt_chain_size_n(2).should == 2
  end

  it "should have no long-chains in v2" do
    @exchange_data_v2.exchanges[0].get_num_alt_chain_size_n(3).should == 0
  end

  it "should have 16 total transplants in v2" do
    @exchange_data_v2.exchanges[0].total_transplants.should == 20
  end
  
  it "should have 7 cycle ids in the exchange list in v2" do
    @exchange_data_v2.exchanges[0].cycles.length.should == 9

    @exchange_data_v2.exchanges[0].cycles[0].id.should == 1
    @exchange_data_v2.exchanges[0].cycles[1].id.should == 5
    @exchange_data_v2.exchanges[0].cycles[2].id.should == 6
    @exchange_data_v2.exchanges[0].cycles[3].id.should == 7
    @exchange_data_v2.exchanges[0].cycles[4].id.should == 9
    @exchange_data_v2.exchanges[0].cycles[5].id.should == 10
    @exchange_data_v2.exchanges[0].cycles[6].id.should == 13
    @exchange_data_v2.exchanges[0].cycles[7].id.should == 14
    @exchange_data_v2.exchanges[0].cycles[8].id.should == 16
  end
  
  it "should have 2 unused altruistics in v2" do
    @exchange_data_v2.exchanges[0].altruistic_used.should == 3
  end
  
  it "should have 2 unused altruistics in v2" do
    @exchange_data_v2.exchanges[0].unused_altruistics.length.should == 2
    
    @exchange_data_v2.exchanges[0].unused_altruistics[0].should == 20
    @exchange_data_v2.exchanges[0].unused_altruistics[1].should == 21
  end

  it "should have a total of 1 3-way with an embedded pairwise" do
    @exchange_data_v2.exchanges[0].get_total_num_embedded_cycles(3,2) == 2
  end

  it "should have a total of 1 4-way with an embedded pairwise" do
    @exchange_data_v2.exchanges[0].get_total_num_embedded_cycles(4,2) == 1
  end
  
  it "should have a total of 1 4-way with an embedded pairwise" do
    @exchange_data_v2.exchanges[0].get_total_num_embedded_cycles(4,3) == 1
  end

  it "should have a total of 0 5-ways with an embedded pairwise" do
    @exchange_data_v2.exchanges[0].get_total_num_embedded_cycles(5,2) == 0
  end
  
  it "should have 15 as the total number of paired transplants" do
    @exchange_data_v2.exchanges[0].total_paired.should == 12
  end 

end